## biosig4c++-1.8.4.src.tar.gz

=== DESCRIPTION ===
Name: BioSig
Version: 1.8.4
Date: 2016-11-22
Author: Alois Schloegl <alois.schloegl@ist.ac.at>
Maintainer: Alois Schloegl
Title: BioSig
Description: A software library for biomedical signal processing.
Depends: octave (> 2.9.0),
License: GPL version 3 or later
Url: http://biosig.sf.net

=== Makefile ===
####### Makefile for "BioSig for C/C++" #####################
###
###  Copyright (C) 2006-2015 Alois Schloegl <alois.schloegl@ist.ac.at>
###  This file is part of the "BioSig for C/C++" repository
###  (biosig4c++) at http://biosig.sf.net/
###
##############################################################

##### Target: GNU/Linux
#
## make && make install    build and install libbiosig, but no other tools.
#             libbiosig is a prerequisite for building all the other tools below.
#
## make save2gdf   - makes converter
## make biosig_fhir   - makes converter for fhir-binary template
## make install_save2gdf   - installs converter
## make install_mma 	installs biosig's sload for Mathematica in $PREFIX/share/biosig/mathematica
## make install_mex 	installs mexbiosig for Matlab in $PREFIX/share/biosig/mex
#
## make mex4o      - makes mexSLOAD, mexSOPEN for Octave (requires Octave-headers)
## make mex4m      - makes mexSLOAD, mexSOPEN for Matlab (requires Matlab, mex -setup must be configured)
## make mexw32     - makes mexSLOAD.mexw32, mexSOPEN.mexw32 (requires that mingw32, gnumex libraries from Matlab/Win32)
## make mexw64     - makes mexSLOAD.mexw64, mexSOPEN.mexw64 (requires that mce-w32, gnumex libraries from Matlab/Win64)
## make mex        - mex4o, mex4m, mexw32, mexw64 combined
## make biosig4python - makes python interface (requires Python)
## make biosig4java - makes Java interface (experimental)
## make biosig4php - makes PHP interface (experimental)
## make biosig4perl - makes perl interface (experimental)
## make biosig4ruby - makes ruby interface (experimental)
## make biosig4tcl - makes tcl/tk interface (experimental)
##
## make win32 and make win64 are obsolete. save2gdf.exe, and libbiosig.{a,dll} for windows can now be built
## with the mingw-cross-compiler environment (mxe.cc).
##    git clone https://github.com/schloegl/mxe.git
##    make biosig
## should do what you want. Please note, that win32mma does now also rely that libbiosig is built with MXE.
## Make sure that CROSS or CROSS64 is properly defined when running `make`
##
## ???
## make sigviewer  - makes sigviewer

##### Target: Win32
## make win32      - makes save2gdf.exe,libbiosig.lib,libbiosig.dll, for MSWindows, requires MinGW
## make mexw32 mex/mexSLOAD.mexw32   - requires MinGW32 and GNUMEX libraries from Matlab/Win32
## make win32/sigviewer.exe 	- requires sources of SigViewer, and MinGW32 (mex: make suitesparse zlib qt )

##### Target: Win64
## make win64      - makes save2gdf.exe,libbiosig.lib,libbiosig.dll, for MSWindows, requires MinGW
## make mexw64 mex/mexSLOAD.mexw64   - requires MCE-W64 and GNUMEX libraries from Matlab/Win64
## make win64/sigviewer.exe 	- requires sources of SigViewer and MCE-W64, make suitesparse zlib qt 

##### Target: MacOSX w/ homebrew
## make install_homebrew	installs libbiosig and save2gdf
	# requires: brew tap homebrew/dupes
	#	    brew install libiconv

###############################
# whether dynamic or static linking is used, can be controlled with
# LIBEXT. Setting it to 'a' links statically, 'so' links dynamically
#
LIBEXT        = a
#LIBEXT	      = so
###############################

### User-specified options: its likely you want to change this
# settings for cross compiler: tested with MXE and mce-w64 with make suitesparse zlib qt ; 
CROSS   = $(HOME)/src/mxe.github.schloegl/usr/bin/i686-w64-mingw32.static
## local MXE
ifeq "$(wildcard $(CROSS)-gcc)" ""
CROSS   = $(HOME)/src/mxe.master/usr/bin/i686-w64-mingw32.static
endif
ifeq "$(wildcard $(CROSS)-gcc)" ""
CROSS         = $(shell pwd)/../mxe/usr/bin/i686-w64-mingw32.static
endif
ifeq "$(wildcard $(CROSS)-gcc)" ""
CROSS         = /usr/local/src/mxe/usr/bin/i686-w64-mingw32.static
endif

CROSS64       = $(HOME)/src/mxe.github.schloegl/usr/bin/x86_64-w64-mingw32.static
ifeq "$(wildcard $(CROSS64)-gcc)" ""
CROSS64       = $(HOME)/src/mxe.master/usr/bin/x86_64-w64-mingw32.static
endif
ifeq "$(wildcard $(CROSS64)-gcc)" ""
CROSS64       = $(HOME)/src/mxe.master/usr/bin/x86_64-w64-mingw32.static
endif

# settings for mex files
MEX_OPTION    = -largeArrayDims # turn on for 64 bit Matlab, otherwise empty
# directory for sources of sigviewer
PathToSigViewer = ../sigviewer
PathToSigViewerWIN32 = ../sigviewer4win32
PathToSigViewerWIN64 = ../sigviewer4win64

CFLAGS       += -std=gnu11
CFLAGS       += -fstack-protector -D_FORTIFY_SOURCE=2 -Wformat -Wformat-security -pipe -fPIC -fno-builtin-memcmp -O2 -Wno-unused-result
CFLAGS       += -Wno-deprecated
CFLAGS       += -D_GNU_SOURCE
CFLAGS       += -D_XOPEN_SOURCE=700
CFLAGS       += -D_DEFAULT_SOURCE
CXXFLAGS      = $(CFLAGS)
CXXFLAGS     += -std=gnu++11

## TARGET dependencies
ifeq (,$(TARGET))
	CC      ?= gcc
	CXX     ?= g++
	AR      := ar rcs
	PKGCONF := pkg-config
	PREFIX  ?= /usr/local
ifneq (Darwin,$(shell uname))
	LFLAGS  += -Wl,-z,relro,-z,now
endif
else ifeq (intel,$(TARGET))
	CC      := /opt/intel/bin/icc
	CXX     := /opt/intel/bin/icc
	LD      := /opt/intel/bin/xild
	AR      := /opt/intel/bin/xiar crs
	PREFIX  ?= /usr/local
else 
	prefix  := $(subst /bin/,/,$(dir $(shell which $(TARGET)-gcc)))
	PREFIX	?= $(dir $(dir $(prefix)))$(TARGET)
	CC      := $(TARGET)-gcc
	CXX     := $(TARGET)-g++
	LD      := $(TARGET)-ld
	AR      := $(TARGET)-ar rcs
	PKGCONF := $(TARGET)-pkg-config
	ifneq (,$(findstring mingw,$(TARGET)))
		## add gnulib's getlogin
		SOURCES += win32/getlogin.c win32/getline.c win32/getdelim.c
		OBJECTS += getlogin.o getline.o getdelim.o
		CFLAGS  += -I.
		LIBS    += -lssp
		LDLIBS  += -liconv -liberty -lws2_32
		BINEXT   = .exe
	endif
endif

ifeq (Darwin,$(shell uname))
	## Homebrew:
	##	brew install gawk
	##	brew install gnu-tar
	##	brew install homebrew/dupes/libiconv
	##	brew install homebrew/science/suite-sparse
	##
	TAR	       = gtar
	LD	       = ld
	CFLAGS        += -I/usr/local/opt/libiconv/include
	LDLIBS        += -L/usr/local/opt/libiconv/lib/ -liconv -lstdc++
	LDFLAGS       += -dylib -arch x86_64 -macosx_version_min 10.10
	DLEXT          = dylib
	FULLDLEXT      = ${BIOSIG_VERSION}.dylib
	SONAME_PREFIX  = -install_name # the last space character is crucial
	SONAME_POSTFIX = .${MAJOR_VERSION}.${MINOR_VERSION}.$(DLEXT)
	prefix        ?= /usr/local

else ifneq (,$(findstring MINGW, $(shell uname)))
	## add gnulib's getlogin
	SOURCES += win32/getlogin.c win32/getline.c win32/getdelim.c
	OBJECTS += getlogin.o getline.o getdelim.o
	## exclude conflicting definition of sopen from mingw's io.h
	CC  = gcc
	CXX = g++
	CFLAGS  += -I.
	CFLAGS  += -pipe -fPIC -D_REENTRANT -D=BUILD_DLL
	LDFLAGS += -shared
	TAR	 = tar
	LD	 = $(CXX)
	DLEXT    = dll
	FULLDLEXT      = ${MAJOR_VERSION}${MINOR_VERSION}.dll
	SONAME_PREFIX  = -Wl,-soname=
	SONAME_POSTFIX = ${MAJOR_VERSION}${MINOR_VERSION}.$(DLEXT)
	LIBS    += -lssp
	LDLIBS  += -liconv -lws2_32 -Wl,-subsystem,windows
	prefix  :=

else
	TAR	       = tar
	LD	       = $(CXX)
	LDFLAGS       += -shared
	DLEXT          = so
	FULLDLEXT      = so.${BIOSIG_VERSION}
	SONAME_PREFIX  = -Wl,-soname=
	SONAME_POSTFIX = .$(DLEXT).${MAJOR_VERSION}.${MINOR_VERSION}
	prefix        ?= /usr/local
endif

DEFINES_ALL   = #-D=NDEBUG

DEFINES      += $(DEFINES_ALL)
#DEFINES      += -D=WITH_SON 
#DEFINES      += -D=WITHOUT_SCP_DECODE
#DEFINES      += -D=WITH_TIMESTAMPEVENT
#DEFINES      += -D=WITH_TIMESTAMPCHANNEL

ifeq (,$(findstring MINGW, $(shell uname)))
             ### MXE_OCTAVE does not provid ZLIB
DEFINES      += -D=WITH_ZLIB
endif

DEFINES      += -D=WITH_PTHREAD
#DEFINES      += -D=WITH_CURL
DEFINES      += -D=__4HAERTEL__
DEFINES      += -D=WITH_FAMOS
DEFINES      += -D=WITH_FIFF
DEFINES      += -D=WITH_CHOLMOD
DEFINES      += -D=WITHOUT_NETWORK
#DEFINES      += -D=WITH_SCP3
#DEFINES      += -D=WITH_HDF
#DEFINES      += -D=WITH_MATIO
#DEFINES      += -D=WITH_LIBXML2 
DEFINES      += -D=WITH_FEF
#DEFINES      += -D=WITH_PDP
#DEFINES      += -D=WITH_DCMTK
#DEFINES      += -D=WITH_DICOM
#DEFINES      += -D=WITH_GDCM
#DEFINES      += -D=WITH_GSL
#DEFINES      += -D=WITH_EEPROBE
#DEFINES      += -D=WITH_TDMS
DEFINES      += -D=WITH_ATF
#DEFINES      += -D=WITH_AVI
#DEFINES      += -D=WITH_RIFF
#DEFINES      += -D=WITH_WAV
#DEFINES      += -D=WITH_NEV
DEFINES      += -D=MAKE_EDFLIB


ifneq (,$(findstring WITH_GDCM, $(DEFINES)))
  INCPATH    += -I$(wildcard /usr/include/gdcm-2*/)
  LDLIBS     += -lgdcmCommon -lgdcmDSED -lgdcmMEXD -lgdcmMSFF -lgdcmDICT -lgdcmIOD
endif
ifneq (,$(findstring WITH_ZLIB, $(DEFINES)))
  LDLIBS     += -lz
endif
ifneq (,$(findstring WITH_PTHREAD, $(DEFINES)))
  LDLIBS     += -lpthread
endif

ifneq (,$(findstring WITH_CHOLMOD, $(DEFINES)))
  LDLIBS     += -lcholmod
ifeq (Darwin,$(shell uname))
  ## homebrew requires this in addition to cholmod
  LDLIBS     += -lsuitesparseconfig
endif
endif

ifneq (,$(findstring WITH_LIBXML2, $(DEFINES)))
  LDLIBS     += -lxml2
endif
ifneq (,$(findstring WITH_CURL, $(DEFINES)))
  LDLIBS     += -lcurl
endif
ifneq (,$(findstring WITH_HDF, $(DEFINES)))
  LDLIBS     += -lhdf5
endif
ifneq (,$(findstring WITH_DCMTK, $(DEFINES)))
  LDLIBS     += -ldcmdata -loflog -lofstd
endif
ifneq (,$(findstring WITH_MATIO, $(DEFINES)))
  LDLIBS     += -lmatio
endif
ifneq (,$(findstring stack-protector, $(CFLAGS)))
ifneq (,$(findstring CYGWIN, $(shell uname)))
  LDLIBS     += -lssp -liconv
endif 
ifneq (,$(findstring MINGW, $(shell uname)))
  LDLIBS     += -lssp -liconv
endif
endif

LIBS         += $(LDLIBS)

DELETE        = rm -f
COPY          = cp -f
DATA_DIR      = data/
DATA_DIR_CFS  = $(HOME)/L/data/test/cfs/
TEMP_DIR      = test/
SED           = sed
VERBOSE	     := -V0

##########################################################
## set Matlab and Octave variables
ifeq (undefined,$(origin MATLABDIR))
  ifeq (Darwin,$(shell uname))
    MATLABDIR := $(shell find /Applications/MATLAB* -name bin -type d -depth 1 2>/dev/null | head -1)
  else
    MATLABDIR ?= $(shell find /usr/local/MATLAB* -maxdepth 2 -name bin -type d 2>/dev/null | head -1)
  endif
endif

ifeq (,$(MATLABDIR))
  #$(warning MATLABDIR is not defined)
else
  MEX         = $(MATLABDIR)/mex
  MEX_EXT    := $(shell $(MATLABDIR)/mexext)
endif


# use environment variable to define OCTAVE_VERSION
#   e.g. export OCTAVE_VERSION=-3.6.2
# Octave - global install  (e.g. from debian package)
#OCTAVE_VERSION = 
# Octave - local install (e.g. compiled from sources) 
#OCTAVE_VERSION = -3.6.1

OCT           := mkoctfile$(OCTAVE_VERSION)
##########################################################

##########################################################
## set variables for Python
SWIG           := swig
PYTHON         ?= python
PYTHONVER      := $(shell $(PYTHON) -c "import sys; print(sys.version[:3])")
NUMPY_INC      := $(shell $(PYTHON) -c "import numpy.distutils.misc_util as mu; print(' -I'.join(mu.get_numpy_include_dirs()))")
PYTHON_INCPATH := /usr/include/python$(PYTHONVER)/
PYTHON_LIB     := python$(PYTHONVER)

 
##########################################################
## set variables for MinGW Crosscompiler: compile on linux binaries for windows
##
PathToMinGW   = $(dir $(CROSS))..$(nondir $(CROSS))
PathToMinGW64 = $(dir $(CROSS64))..$(nondir $(CROSS64))

MinGWCC      = $(CROSS)-gcc
MinGWCXX     = $(CROSS)-g++
MinGWDEF     = $(DEFINES) 
MinGWCFLAGS  = -pipe -fPIC  -D_REENTRANT -D=BUILD_DLL $(MinGWDEF) -Iwin32 -I$(PathToMinGW)/include/
MinGWLIBS    = win32/libbiosig.a -L$(PathToMinGW)/lib/ $(LDLIBS) # static
MinGWLINK    = $(MinGWCXX)

MinGW64CC      = $(CROSS64)-gcc
MinGW64CXX     = $(CROSS64)-g++
MinGW64CFLAGS  = -pipe -fPIC -O2 -D_REENTRANT -D=BUILD_DLL $(MinGWDEF) -Iwin64 -I$(PathToMinGW64)/include/
MinGW64LIBS    = win64/libbiosig.a -L$(PathToMinGW64)/lib/ $(LDLIBS) # static
MinGW64LINK    = $(MinGW64CXX)
##########################################################

# Versioning
MAJOR_VERSION  := $(word 3, $(shell grep '\#define BIOSIG_VERSION_MAJOR' biosig.h))
MINOR_VERSION  := $(word 3, $(shell grep '\#define BIOSIG_VERSION_MINOR' biosig.h))
STEPPING       := $(word 3, $(shell grep '\#define BIOSIG_PATCHLEVEL' biosig.h))

=== R/Makefile ===

#gcc -I/usr/share/R/include/ sload.c -lbiosig
 
CFLAGS += -I/usr/share/R/include
#LFLAGS += -lR -lbiosig -lbiosig2
LFLAGS += ../libbiosig.a ../libbiosig2.a

sload.so: sload.c
	R CMD SHLIB sload.c ${LFLAGS} ${LIBS}

sload.o: sload.c
	gcc $(CFLAGS) -c "$<" -o "$@"

clean:
	rm *.o *.so

=== examples/Makefile ===

all: test

%:%.c 
	$(CC) -DHL1 $< -lbiosig2 -lm -o $@.HL1
	$(CC) -DHL2 $< -lbiosig2 -lm -o $@.HL2
	$(CC) -DLL1 $< -lbiosig2 -lm -o $@.LL1
	$(CC) -DLL2 $< -lbiosig2 -lm -o $@.LL2
	
	
test: generate_gdf_file
	-./generate_gdf_file.HL1 hl1.gdf
	-./generate_gdf_file.HL2 hl2.gdf
	-./generate_gdf_file.LL1 ll1.gdf
	-./generate_gdf_file.LL2 ll2.gdf
	
clean:
	rm *.gdf generate_gdf_file.[HL]L[12]

=== mma/Makefile ===
####### Makefile to compile sload.exe for loading data supported by libbiosig into Mathematica
###
###  Copyright (C) 2010,2011,2012,2013,2015,2016 Alois Schloegl <alois.schloegl@gmail.com>
###  This file is part of the "BioSig for C/C++" repository
###  (biosig4c++) at http://biosig.sf.net/
###
##############################################################


###########################################
# user-defined variables 
###########################################
CROSS   ?= /home/schloegl/src/mxe.github.schloegl/usr/bin/i686-w64-mingw32.static
CROSS64 ?= /home/schloegl/src/mxe.github.schloegl/usr/bin/x86_64-w64-mingw32.static

LDLIBS  ?= -lz -lpthread -lcholmod -liconv
 
###########################################
## set Mathematica variables

#MLINKDIR = /usr/local/Wolfram/gridMathematicaServer/7.0
#MLINKDIR = /usr/local/Wolfram/Mathematica/8.0
#MLINKDIR = /usr/local/Wolfram/Mathematica/9.0
#MLINKDIR = /usr/local/Wolfram/Mathematica/10.0

ifeq (Darwin,$(shell uname))
MLINKDIR := /Applications/Mathematica.app/Contents/
SYS       = MacOSX-x86-64
LDFLAGS  += -demangle -dynamic -arch x86_64 -macosx_version_min 10.10.0
LDFLAGS  += -framework CoreFoundation -framework CoreVideo -framework VideoDecodeAcceleration
else
MLINKDIR := $(dir $(shell readlink -f $(shell which mathematica) ) )..
SYS 	  = $(notdir $(shell ls -1d $(MLINKDIR)/SystemFiles/Links/MathLink/DeveloperKit/*))
ifneq (1,$(words ${SYS}))
SYS       = Linux-x86-64# Set this value with the result of evaluating $SystemID
endif
endif

# automated detection of most recent MLINTERFACE, without starting mathematica
# 10.0 supports 3 and 4, 9.0 and earlier supports only 3,
MLIVER := $(shell ${CC} mliver.c -I${MLINKDIR}/SystemFiles/Links/MathLink/DeveloperKit/${SYS}/CompilerAdditions/ -E -o - | tail -1)

#
# Windows
#MLINKDIR  = /usr/local/Wolfram/gridMathematicaServer/7.0/SystemFiles/Links/MathLink/DeveloperKit
SYSwin       = Windows# Set this value with the result of evaluating $SystemID
MLLIBwin     = ml32i3m# Set this to ML64i3 if using a 64-bit system
SYSwin64     = Windows-x86-64# Set this value with the result of evaluating $SystemID
MLLIBwin64   = ml64i3m# Set this to ML64i3 if using a 64-bit system
###########################################

CADDSDIR  = ${MLINKDIR}/SystemFiles/Links/MathLink/DeveloperKit/${SYS}/CompilerAdditions
INCDIR    = -I${CADDSDIR} -I${MLINKDIR}/SystemFiles/IncludeFiles/C/
LIBDIR   += -L${CADDSDIR}

EXTRALIBS += -lm -ldl -luuid # Set these with appropriate libs for your system.

ifeq (Darwin,$(shell uname))
MLLIB   = MLi${MLIVER} # ML32i3 # Set this to ML64i3 if using a 64-bit system
SED	= gsed
else
MLLIB   = ML$(shell getconf LONG_BIT)i${MLIVER} # ML32i3 # Set this to ML64i3 if using a 64-bit system
EXTRALIBS += -lrt
LD 	= ${CC}
SED	= sed
endif


ifneq (${MLIVER},)
CFLAGS += -DMLINTERFACE=${MLIVER}
endif

MPREP     = ${CADDSDIR}/mprep

TARGET = sload

all : ${TARGET}.exe ${SYSwin}/${TARGET}.exe ${SYSwin64}/${TARGET}.exe
mma : ${TARGET}.exe

.c.o:
	${CC} ${CFLAGS} -c ${INCDIR} "$<"

${TARGET}tm.c: ${TARGET}.tm
	${MPREP} "$<" -o "$@"
	# enable macro expansion
	${SED} -i 's# __DATE__# ",__DATE__," ",__TIME__,"#' "$@"

${TARGET}.exe: ${TARGET}.o ${TARGET}tm.o
	mkdir -p ${SYS}
	# static linking
	${LD} ${LDFLAGS} ${TARGET}tm.o ${TARGET}.o ../libbiosig2.a $(shell pkg-config --libs libbiosig) -lstdc++ ${LIBDIR} -l${MLLIB} ${EXTRALIBS} -o ${SYS}/"$@"
	# dynamic linking
	#${LD} ${LDFLAGS} ${TARGET}tm.o ${TARGET}.o $(shell pkg-config --libs libbiosig) -lbiosig2 -lstdc++ ${LIBDIR} -l${MLLIB} ${EXTRALIBS} -o ${SYS}/"$@"
	ln -sf ${SYS}/"$@"


###########################################
#   Win32 - cross-compilation 
###########################################

CCw32        = $(CROSS)-gcc
CADDSDIRwin  = ${MLINKDIR}/SystemFiles/Links/MathLink/DeveloperKit/${SYSwin}/CompilerAdditions/mldev32
INCDIRwin    = -I${CADDSDIRwin}/include  -I${MLINKDIR}../SystemFiles/IncludeFiles/C/
LIBDIRwin    = ${CADDSDIRwin}/lib

EXTRALIBSwin = -lgdi32 -lm -lstdc++ -lws2_32 $(LDLIBS) # Set these with appropriate libs for your system.

MPREPwin     = ${CADDSDIRwin}/bin/mprep.exe

${TARGET}tm.win32.c : ${TARGET}.tm
	WINEPREFIX=${HOME}/.wine32.mma wine ${MPREPwin} "$<" -o "$@"
	sed -i 's# __DATE__# ",__DATE__," ",__TIME__,"#' "$@"

${TARGET}.obj : ${TARGET}.c
	${CCw32} -c ${INCDIRwin} "$<" -o "$@"
${TARGET}tm.obj : ${TARGET}tm.win32.c
	${CCw32} -c ${INCDIRwin} "$<" -o "$@"

win32mma : ${SYSwin}/${TARGET}.exe

${SYSwin}/${TARGET}.exe : ${TARGET}.obj ${TARGET}tm.obj
	mkdir -p ${SYSwin}
	${CCw32} $^ -mwindows -static-libgcc -static-libstdc++ -lbiosig2 -lssp -L${LIBDIRwin} -l${MLLIBwin} ${EXTRALIBSwin} -o "$@"
	# copy to users directory if available
	-cp -r ${SYSwin} ~/K/Software/MathematicaTools/${TARGET}


###########################################
#   Win64 - cross-compilation 
###########################################

CCw64         = $(CROSS64)-gcc
CADDSDIRwin64 = ${MLINKDIR}/SystemFiles/Links/MathLink/DeveloperKit/${SYSwin64}/CompilerAdditions/mldev64
INCDIRwin64   = -I${CADDSDIRwin64}/include -I${MLINKDIR}../SystemFiles/IncludeFiles/C/
LIBDIRwin64   = ${CADDSDIRwin64}/lib

MPREPwin64    = ${CADDSDIRwin64}/bin/mprep.exe

${TARGET}tm.win64.c : ${TARGET}.tm
	WINEPREFIX=${HOME}/.wine64.mma wine64 ${MPREPwin64} "$<" -o "$@"
	#${MPREP} "$<" -o "$@"
	sed -i 's# __DATE__# ",__DATE__," ",__TIME__,"#' "$@"

${TARGET}.w64obj : ${TARGET}.c
	${CCw64} -c ${INCDIRwin64} "$<" -o "$@"
${TARGET}tm.w64obj : ${TARGET}tm.win64.c
	${CCw64} -c ${INCDIRwin64} "$<" -o "$@"

win64mma : ${SYSwin64}/${TARGET}.exe

### curentlly the 64bit MXE cross-compilation does not work - use instead use 32bit version i
#${SYSwin64}/${TARGET}.exe : ${TARGET}.w64obj ${TARGET}tm.w64obj
${SYSwin64}/${TARGET}.exe : ${SYSwin}/${TARGET}.exe
	mkdir -p ${SYSwin64}
#	${CCw64} $^ -static-libgcc -static-libstdc++ -lbiosig2 -lssp -L${LIBDIRwin64} -l${MLLIBwin64} ${EXTRALIBSwin} -o "$@"
	-cp "$<" "$@"


###########################################
clean:
	-$(RM) *.o
	-$(RM) *.obj
	-$(RM) *tm.c
	-$(RM) ${SYSwin64}/${TARGET}.exe ${SYSwin32}/${TARGET}.exe
	-$(RM) ${SYS}/${TARGET} ${SYS}/${TARGET}.exe

=== python/Makefile ===
####### Makefile for "BioSig for C/C++" #####################
###
###  Copyright (C) 2006,2007,2008,2009,2012,2016 Alois Schloegl <alois.schloegl@ist.ac.at>
###  This file is part of the "BioSig for C/C++" repository 
###  (biosig4c++) at http://biosig.sf.net/ 
###
##############################################################

PYTHON ?= python
PYVER  := $(shell $(PYTHON) -c "import sys; print(sys.version[:3])")


# old style, using swig interface
biosig4python:
	make -C .. biosig4python


# new interface, using so-called "extension modules", this still experimental
module:
	$(PYTHON) setup.py build

install: module
	$(PYTHON) setup.py install

test:
	## get ../data/Newtest17-256.bdf
	make -C .. fetchdata
	## need to run from different directory, because
	(cd .. && PYTHONPATH=/usr/local/lib/python$(PYVER)/dist-packages/ $(PYTHON) -c 'import biosig; print biosig.header("data/Newtest17-256.bdf")')
	(cd .. && PYTHONPATH=/usr/local/lib/python$(PYVER)/dist-packages/ $(PYTHON) -c 'import biosig; print biosig.data("data/Newtest17-256.bdf")')
	(cd .. && PYTHONPATH=/usr/local/lib/python$(PYVER)/dist-packages/ python$(PYVER) < python/demo2.py)

=== macports/science/libbiosig/Portfile ===
# -*- coding: utf-8; mode: tcl; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- vim:fenc=utf-8:ft=tcl:et:sw=4:ts=4:sts=4
# $Id$

PortSystem          1.0
PortGroup           cmake 1.0

name                libbiosig
version             1.8.0
categories          science
platforms           darwin
license             GPL-3
maintainers         gmx.de:christsc
description         I/O library for biomedical data
long_description    BioSig is a library for accessing files in several \
                    biomedical data formats (including EDF, BDF, GDF, \
                    BrainVision, BCI2000, CFWB, HL7aECG, SCP_ECG (EN1064), \
                    MFER, ACQ, CNT(Neuroscan), DEMG, EGI, EEG1100, FAMOS, \
                    SigmaPLpro, TMS32)
homepage            http://biosig.sourceforge.net/index.html
master_sites        sourceforge:biosig
master_sites.mirror_subdir \
                    /BioSig%20for%20C_C++/src
distname            biosig4c++-${version}.src
worksrcdir          biosig4c++-${version}
checksums           rmd160  267c4a380eeb2ecedf3d770ebd0ac67aefb656cc \
                    sha256  dae843b2dc0835542ff9c4e4afe22dcfaae32fba9c78a3401ce3c738ef4cc6d5

depends_build-append \
                    port:gawk
depends_lib         port:SuiteSparse \
                    port:zlib \
                    port:libiconv

cmake.out_of_source yes

configure.args-append \
                    -DUSE_SUITESPARSE=ON \
                    -DUSE_ZLIB=ON \
                    -DZLIB_INCLUDE_DIR=${prefix}/include \
                    -DZLIB_LIBRARY=${prefix}/lib/libz.dylib \
                    -DICONV_LIBRARY=${prefix}/lib/libiconv.dylib \
                    -DCHOLMOD_LIBRARY=${prefix}/lib/libcholmod.dylib

configure.cflags-append \
                    -DMACPORTS

configure.cxxflags-append \
                    -DMACPORTS

livecheck.regex     biosig4c\\+\\+-(\[0-9a-z.\]+)\\.src${extract.suffix}
